if(window.RSDKClient==undefined)
{
    window.RSDKClient=function(){};
}
RSDKClient.appForegroundStatusChangeCallback=function(){};
//function RSDKClient(){
//
//}
RSDKClient.prototype = {
    constructor:RSDKClient,

    //登录接口  customData：登录自定义参数，开发者将自定义参数传入 customData 中，在登录成功回调中可获取原样值。开发者可以通过该字段做校验的功能或者其他功能。
    login:function(customData, callback) {
        RSDKClient.loginCallback = function(code, msg) {
            switch (code) {
                case RSDKCode.RET_LOGIN_SUCCESS:
                    callback(code, JSON.parse(msg));
                    break;
                case RSDKCode.RET_LOGIN_FAIL:
                    var userInfo = {msg:msg}
                    callback(code, userInfo);
                    break;
                case RSDKCode.RET_LOGIN_CANCEL:
                    var userInfo = {msg:msg}
                    callback(code, userInfo);
                    break;
                case RSDKCode.RET_LOGOUT_SUCCESS:
                    var userInfo = {msg:msg}
                    callback(code, userInfo);
                    break;
                case RSDKCode.RET_LOGOUT_FAIL:
                    var userInfo = {msg:msg}
                    callback(code, userInfo);
                    break;
                default:
                    var userInfo = {msg:msg}
                    callback(code, userInfo);
                    break;
            }
        };
        doRSDKLogin(customData);
    },
    //注销接口
    logout:function() {
        doRSDKLogout();
    },
    //支付接口
    pay:function(productInfo, callback) {
        RSDKClient.payCallback = callback;
        doRSDKPay(productInfo);
    },
    //统计接口
    trackEvent:function(eventCode,eventInfo){
        doRSDKAnalytics(eventCode,eventInfo);
    },
    share:function(shareInfo, callback){
        RSDKClient.shareCallback = callback;
        doRSDKShare(shareInfo);
    },
    //获取Android系统API Level
    getAndroidAPILevel:function() {
        return doRSDKGetAndroidAPILevel();
    },
    //自定义方法接口(带String返回值)
    callStringFunction:function(functionType, functionName, functionParam, callback){
        RSDKClient[functionName + "Callback"] = callback;
        return doRSDKCallStringFunction(functionType, functionName, functionParam);
    },
    //自定义方法接口（无返回值）
    callFunction:function(functionType, functionName, functionParam, callback){
        if (callback) {
            RSDKClient.callFunctionCallback = callback;
        }
        doRSDKCallFunction(functionType, functionName, functionParam);
    },
    // 自定义方法接口（带异步回调）
    callCustomFunctionWithCallback:function(functionType, functionName, functionParam, callback){
        if (callback) {
            RSDKClient[functionName + "Callback"] = callback;
        }
        doRSDKCallCustomFunctionWithCallback(functionType, functionName, functionParam);
    },
    //获取版本号
    getVersion:function(callback) {
        RSDKClient.getVersionCallback = callback;
        return doRSDKGetVersion();
    },
    //获取设备id
    getDeviceId:function(callback) {
        RSDKClient.getDeviceIdCallback = callback;
        return doRSDKGetDeviceId();
    },
    //获取统计id
    getSubAppId:function(callback){
        RSDKClient.getSubAppIdCallback = callback;
        return doRSDKGetSubAppId();
    },
    //设置app进入后台/进入前台的回调
    setAppForegroundStatusChangeCallback(callback) {
        RSDKClient.appForegroundStatusChangeCallback = callback;
    }

}

//登录
function doRSDKLogin(customData) {
    alert("调用RSDKClient登录接口，传入参数透传字段customData：" + customData);

    if (isAndroidPlatform()) {
        RSDKPlatform.login(customData);
    } else if (isIOSPlatform()) {
        window.webkit.messageHandlers.RSDKLogin.postMessage(customData);
    }
}

//注销
function doRSDKLogout() {
    alert("调用RSDKClient注销接口");

    if (isAndroidPlatform()) {
        RSDKPlatform.logout();
    } else if (isIOSPlatform()) {
        window.webkit.messageHandlers.RSDKLogout.postMessage([]);
    }
}

//支付
function doRSDKPay(productInfo) {
    alert("调用RSDKClient支付接口，参数：" + JSON.stringify(productInfo));

    if (isAndroidPlatform()) {
        RSDKPlatform.pay(JSON.stringify(productInfo));
    } else if (isIOSPlatform()) {
        window.webkit.messageHandlers.RSDKPay.postMessage(productInfo);
    }
}

//统计
function doRSDKAnalytics(eventCode,eventInfo){
    switch(eventCode){
        case RSDKCode.EVENT_NAME_COMPLETED_LOGIN:
            alert("调用RSDKClient登录统计接口，参数：" + JSON.stringify(eventInfo));
            break;
        case RSDKCode.EVENT_NAME_TUTORIAL_STEP:
            alert("调用RSDKClient新手引导步数统计接口，参数：" + JSON.stringify(eventInfo));
            break;
        case RSDKCode.EVENT_NAME_COMPLETED_REGISTRATION:
            alert("调用RSDKClient注册统计接口，参数：" + JSON.stringify(eventInfo));
            break;
        case RSDKCode.EVENT_NAME_COMPLETED_PAY:
            alert("调用RSDKClient支付统计接口，参数：" + JSON.stringify(eventInfo));
            break;
        case RSDKCode.EVENT_NAME_USERUPDATE:
            alert("调用RSDKClient升级统计接口，参数：" + JSON.stringify(eventInfo));
            break;
        case RSDKCode.EVENT_NAME_COMPLETED_TUTORIAL:
            alert("调用RSDKClient新手引导完成统计接口，参数：" + JSON.stringify(eventInfo));
            break;
        case RSDKCode.EVENT_NAME_LOADING_END:
            alert("调用RSDKClient LOADING END 统计接口，参数：" + JSON.stringify(eventInfo));
            break;
    }

    if (isAndroidPlatform()) {
        RSDKPlatform.logEvent(eventCode, JSON.stringify(eventInfo));
    } else if (isIOSPlatform()) {
        window.webkit.messageHandlers.RSDKAnalytics.postMessage([eventCode,eventInfo]);
    }
}

//分享
function doRSDKShare(shareInfo) {
    if (isAndroidPlatform()) {
        RSDKPlatform.share(JSON.stringify(shareInfo));
    } else if (isIOSPlatform()) {
        window.webkit.messageHandlers.RSDKShare.postMessage(shareInfo);
    }
}

//自定义方法(带String返回值)
function doRSDKCallStringFunction(functionType, functionName, functionParam) {
    if (isAndroidPlatform()) {
        return RSDKPlatform.callStringFunction(functionType, functionName, functionParam);
    } else if (isIOSPlatform()) {
        return window.webkit.messageHandlers.RSDKCallStringFunction.postMessage([functionType, functionName, functionParam]);
    }
}

function doRSDKCallFunction(functionType, functionName, functionParam) {
    if (isAndroidPlatform()) {
        RSDKPlatform.callFunction(functionType, functionName, functionParam);
    } else if (isIOSPlatform()) {
        window.webkit.messageHandlers.RSDKCallFunction.postMessage([functionType, functionName, functionParam]);
    }
}

function doRSDKCallCustomFunctionWithCallback(functionType, functionName, functionParam) {
    if (isAndroidPlatform()) {
        RSDKPlatform.callCustomFunctionWithCallback(functionType, functionName, functionParam);
    } else if (isIOSPlatform()) {
        window.webkit.messageHandlers.RSDKCallCustomFunctionWithCallback.postMessage([functionType, functionName, functionParam]);
    }
}

function doRSDKGetDeviceId() {
    if (isAndroidPlatform()) {
        return RSDKPlatform.getDeviceId();
    } else if (isIOSPlatform()) {
        window.webkit.messageHandlers.RSDKGetDeviceId.postMessage([]);
    }
}

function doRSDKGetSubAppId() {
    if (isAndroidPlatform()) {
        return RSDKPlatform.getSubAppId();
    } else if (isIOSPlatform()) {
        window.webkit.messageHandlers.RSDKGetSubAppId.postMessage([]);
    }
}

function doRSDKGetVersion() {
    if (isAndroidPlatform()) {
        return RSDKPlatform.getVersion();
    } else if (isIOSPlatform()) {
        window.webkit.messageHandlers.RSDKGetVersion.postMessage([]);
    }
}

function doRSDKGetAndroidAPILevel() {
    if (isAndroidPlatform()) {
        return RSDKPlatform.getAndroidAPILevel();
    } else if (isIOSPlatform()) {

    }
}

if (window.RSDKWebSocket==undefined)
{
    window.RSDKWebSocket=function(objectName){
        if (isAndroidPlatform()) {
            RSDKPlatform.createWebSocket(objectName);
        }
    };
}
RSDKWebSocket.prototype = {
    constructor:RSDKWebSocket,

    //WebSocket connect接口
    connectWebSocket:function(objectName,host) {
        doRSDKConnectWebSocket(objectName,host);
    },
    //WebSocket发送消息接口
    sendWebSocketMessage:function(objectName,msg) {
        doRSDKSendWebSocketMessage(objectName,msg);
    },
    //WebSocket disconnect接口
    disconnectWebSocket:function(objectName){
        doRSDKDisconnectWebSocket(objectName);
    },
    //WebSocket设置回调接口
    setWebSocketCallback(objectName,callback) {
        window[objectName].webSocketCallback = callback;
//        RSDKWebSocket.prototype.webSocketCallback = callback;
    },
}

function doRSDKConnectWebSocket(objectName, host) {
    if (isAndroidPlatform()) {
        RSDKPlatform.connectWebSocket(objectName, host);
    } else if (isIOSPlatform()) {

    }
}

function doRSDKSendWebSocketMessage(objectName, msg) {
    if (isAndroidPlatform()) {
        RSDKPlatform.sendWebSocketMessage(objectName, msg);
    } else if (isIOSPlatform()) {

    }
}

function doRSDKDisconnectWebSocket(objectName) {
    if (isAndroidPlatform()) {
        RSDKPlatform.disconnectWebSocket(objectName);
    } else if (isIOSPlatform()) {

    }
}

/*
 支付商品对象
 */
function productInfo(){

}
productInfo.prototype = {
    constructor:productInfo,
    price:"",           //商品价格，单位元
    productId:"",       //商品 ID
    productName:"",     //商品名称
    coinNum:"",         //钻石/金币数量
    productCount:"",    //商品份数
    productType:"",     //商品类型
    serverId:"",        //区服 ID，游戏中某个区服的唯一标识号
    gameUserId:"",      //游戏角色 ID
    gameUserName:"",    //游戏角色名称
    roleLevel:"",       //游戏角色等级
    roleVipLevel:"",    //VIP 等级
    currency:"",        //币种代码
    privateData:"",     //透传字段，会在后台支付成功回调时作为private_data参数返回
}

/*
 统计对象
 */
function analyticsEventInfo(){

}
analyticsEventInfo.prototype = {
    constructor:analyticsEventInfo,
    gameUserId:"",      //游戏角色ID
    gameUserName:"",    //游戏角色名
    roleLevel:"",       //游戏角色等级，默认值 "1" 级
    roleVipLevel:"",    //VIP 等级，默认值 "0" 级
    serverId:"",        //区服 ID，当前玩家所在区服的唯一标识号
    serverName:"",      //区服名称，默认值 ""
    registerTime:"",    //游戏角色创建时间戳（精确到秒，10位），不能提供请传空字符串
    step:"",            //新手引导步数
}

/*
 分享对象
 */
function shareInfo(){}
shareInfo.prototype = {
    constructor:shareInfo,
    title:"",         //分享的标题
    desc:"",     //分享的文本内容
    link:"",            //分享的跳转地址
    imageurl:"",         //分享的图片链接
}

/*
 Code
 */
function RSDKCode() {
}
RSDKCode.EVENT_NAME_COMPLETED_LOGIN = "-1";
RSDKCode.EVENT_NAME_TUTORIAL_STEP = "-2";
RSDKCode.EVENT_NAME_COMPLETED_REGISTRATION = "-3";
RSDKCode.EVENT_NAME_COMPLETED_PAY = "-4";
RSDKCode.EVENT_NAME_USERUPDATE = "-5";
RSDKCode.EVENT_NAME_LOADING_END = "-6";
RSDKCode.EVENT_NAME_COMPLETED_TUTORIAL = "-7";

RSDKCode.RET_INIT_SUCCESS = "0";
RSDKCode.RET_INIT_FAIL = "1";

RSDKCode.RET_LOGIN_SUCCESS = "2";
RSDKCode.RET_LOGIN_FAIL = "3";
RSDKCode.RET_LOGIN_CANCEL = "4";

RSDKCode.RET_LOGOUT_SUCCESS = "5";
RSDKCode.RET_LOGOUT_FAIL = "6"

RSDKCode.RET_PAY_SUCCESS = "7";
RSDKCode.RET_PAY_FAIL = "8"
RSDKCode.RET_PAY_CANCEL = "9";

RSDKCode.RET_WEBSOCKET_CONNECT_SUCCEED = "10";//连接成功
RSDKCode.RET_WEBSOCKET_CONNECT_FAIL = "11";//连接失败
RSDKCode.RET_WEBSOCKET_CONNECT_DIS = "12";//连接断开
RSDKCode.RET_WEBSOCKET_CONNECT_TIMEOUT = "13";//连接超时
RSDKCode.RET_WEBSOCKET_RECEIVE_MSG_SUCCEED = "14";//接收消息成功
RSDKCode.RET_WEBSOCKET_ERROR = "15";//错误

RSDKCode.RET_SHARE_SUCCESS = "0";
RSDKCode.RET_SHARE_FAIL = "17";

function isAndroidPlatform() {
    return getMobileOperatingSystem() == "Android";
}

function isIOSPlatform() {
    return getMobileOperatingSystem() == "iOS";
}

/**
 * Determine the mobile operating system.
 * This function returns one of 'iOS', 'Android', 'Windows Phone', or 'unknown'.
 *
 * @returns {String}
 */
function getMobileOperatingSystem() {
    var userAgent = navigator.userAgent || navigator.vendor || window.opera;

    if (/windows phone/i.test(userAgent)) {
        return "Windows Phone";
    }

    if (/android/i.test(userAgent)) {
        return "Android";
    }

    if (/iPad|iPhone|iPod/.test(userAgent) && !window.MSStream) {
        return "iOS";
    }

    return "unknown";
}
